# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%global Name BeanShell
%global namedversion 2.0b4

%define section free

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/beanshell/bsh/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

Name:           bsh2
Version:        2.0
Release:        0.b4.11%{?dist}
Epoch:          0
Summary:        Lightweight Scripting for Java
License:        LGPLv2+
Group:          Development/Java
URL:            http://www.beanshell.org/
Source0:        http://www.beanshell.org/bsh-2.0b4-src.jar
# http://mirrors.ibiblio.org/pub/mirrors/maven2/org/beanshell/bsh-classpath/2.0b4/bsh-classpath-2.0b4.pom
Source1:        bsh-classpath-2.0b4.pom
# http://mirrors.ibiblio.org/pub/mirrors/maven2/org/beanshell/bsh-commands/2.0b4/bsh-commands-2.0b4.pom
Source2:        bsh-commands-2.0b4.pom
# http://mirrors.ibiblio.org/pub/mirrors/maven2/org/beanshell/bsh-core/2.0b4/bsh-core-2.0b4.pom
Source3:        bsh-core-2.0b4.pom
# http://mirrors.ibiblio.org/pub/mirrors/maven2/org/beanshell/bsh-reflect/2.0b4/bsh-reflect-2.0b4.pom
Source4:        bsh-reflect-2.0b4.pom
# http://mirrors.ibiblio.org/pub/mirrors/maven2/org/beanshell/bsh-util/2.0b4/bsh-util-2.0b4.pom
Source5:        bsh-util-2.0b4.pom
# http://mirrors.ibiblio.org/pub/mirrors/maven2/org/beanshell/bsh/2.0b4/bsh-2.0b4.pom
Source6:        bsh-2.0b4.pom
# http://mirrors.ibiblio.org/pub/mirrors/maven2/org/beanshell/bsh-bsf/2.0b4/bsh-bsf-2.0b4.pom
Source7:        bsh-bsf-2.0b4.pom
# http://mirrors.ibiblio.org/pub/mirrors/maven2/org/beanshell/bsh-classgen/2.0b4/bsh-classgen-2.0b4.pom
Source8:        bsh-classgen-2.0b4.pom
# redirecting pom that redirects bsh:bsh to org.beanshell:bsh
# http://repo2.maven.org/maven2/bsh/bsh/2.0b4/bsh-2.0b4.pom
#Source9:       bsh-2.0b4-redirect.pom
# http://mirrors.ibiblio.org/pub/mirrors/maven2/org/beanshell/beanshell/2.0b4/beanshell-2.0b4.pom
Source10:       beanshell-2.0b4.pom
Source11:       bsh2-component-info.xml
Patch0:         %{name}-jedit.patch
Patch1:         %{name}-crosslink.patch
Patch2:         %{name}-xsl.patch
Patch3:         %{name}-bsf.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  ant
BuildRequires:  ant-trax
BuildRequires:  bsf
BuildRequires:  bsf-javadoc
%if 0
BuildRequires:  java-javadoc
%endif
BuildRequires:  javacc
BuildRequires:  jpackage-utils
BuildRequires:  maven2-plugin-deploy
BuildRequires:  servlet_2_5_api
Buildarch:      noarch
Buildroot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
BeanShell is a small, free, embeddable, Java source interpreter with
object scripting language features, written in Java. BeanShell executes
standard Java statements and expressions, in addition to obvious
scripting commands and syntax. BeanShell supports scripted objects as
simple method closures like those in Perl and JavaScript(tm).
You can use BeanShell interactively for Java experimentation and
debugging or as a simple scripting engine for your applications. In
short: BeanShell is a dynamically interpreted Java, plus some useful
stuff. Another way to describe it is to say that in many ways BeanShell
is to Java as Tcl/Tk is to C: BeanShell is embeddable - You can call
BeanShell from your Java applications to execute Java code dynamically
at run-time or to provide scripting extensibility for your applications.
Alternatively, you can call your Java applications and objects from
BeanShell; working with Java objects and APIs dynamically. Since
BeanShell is written in Java and runs in the same space as your
application, you can freely pass references to "real live" objects into
scripts and return them as results.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%package bsf
Summary:        BSF support for %{name}
Group:          Development/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       bsf

%description bsf
BSF support for %{name}.

%package classgen
Summary:        ASM support for %{name}
Group:          Development/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description classgen
ASM support for %{name}.

%package manual
Summary:        Manual for %{name}
Group:          Development/Java

%description manual
Documentation for %{name}.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Java
Requires:       jpackage-utils

%description javadoc
Javadoc for %{name}.

%package demo
Summary:        Demos for %{name}
Group:          Development/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description demo
Demonstrations and samples for %{name}.

%package bshservlet
Summary:        War for %{name}
Group:          Development/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       servlet_2_5_api

%description bshservlet
War for %{name}.

%package bshservlet-wbsh
Summary:        War for %{name}
Group:          Development/Java
Requires:       servlet_2_5_api

%description bshservlet-wbsh
War for %{name} with the BSH %{namedversion} JAR included.

%prep
%setup -q -n %{Name}-%{namedversion}
%patch0 -p1 -b .sav0
%patch1 -p1 -b .sav1
%patch2 -p1 -b .sav2
%patch3 -p1 -b .sav3

%{_bindir}/find -name "*.jar" | %{_bindir}/xargs -t %{__rm}

# set VERSION
%{__perl} -p -i -e 's|VERSION =.*;|VERSION = "%{epoch}:%{version}-%{release}";|' src/bsh/Interpreter.java

%{__rm} src/bsh/bsh.jj
%{__rm} src/bsh/TokenMgrError.java
%if 0
# FIXME: This file was hand-modified after generation
%{__rm} src/bsh/ParseException.java
%endif
%{__rm} src/bsh/Token.java
%{__rm} src/bsh/JavaCharStream.java

%if 0
# FIXME: remove internal asm code, use JPackage external jar instead
%{__rm} -r asm/src/bsh/org
%{__perl} -p -i.orig -e 's|bsh.org.objectweb.asm|org.objectweb.asm|' src/bsh/ClassGeneratorUtil.java
%endif

# scripts
for i in `%{_bindir}/find tests -type f -name "*.bsh"`; do
    %{__perl} -p -i -e 's,^\n?#!(/(usr/)?bin/java bsh\.Interpreter|/bin/sh),#!%{_bindir}/%{name},' $i
done

%build
export OPT_JAR_LIST=`%{__cat} %{_sysconfdir}/ant.d/trax`
export CLASSPATH=$(%{_bindir}/build-classpath bsf javacc servlet_2_5_api)
%{ant} \
       -Dbuild.sysclasspath=first \
%if 0
       -Dexclude-servlet='bsh/servlet/*' \
       -Dasm.javadoc=%{_javadocdir}/asm \
%endif
       -Dbsf.javadoc=%{_javadocdir}/bsf \
       -Djava.javadoc=%{_javadocdir}/java \
       dist
(cd docs/faq && %{ant})
(cd docs/manual && %{ant})

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}/%{name}
for jar in dist/*.[jw]ar; do
  %{__cp} -p ${jar} %{buildroot}%{_javadir}/%{name}/
done
(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} ${jar/-%{namedversion}/}; done)

# manual
%{__mkdir_p} %{buildroot}%{_docdir}/%{name}-doc
%{__cp} -pr docs/* %{buildroot}%{_docdir}/%{name}-doc
pushd %{buildroot}%{_docdir}/%{name}-doc
%{__rm} -r manual/xsl
%{_bindir}/find -type f ! \( -name \*.html -o -name \*.gif -o -name \*.jpg \) | %{_bindir}/xargs -t rm
popd

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__cp} -pr javadoc/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

# pom
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p %{SOURCE1} %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-bsh-classpath.pom
%add_to_maven_depmap org.beanshell bsh-classpath %{namedversion} JPP/%{name} bsh-classpath
%{__cp} -p %{SOURCE2} %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-bsh-commands.pom
%add_to_maven_depmap org.beanshell bsh-commands %{namedversion} JPP/%{name} bsh-commands
%{__cp} -p %{SOURCE3} %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-bsh-core.pom
%add_to_maven_depmap org.beanshell bsh-core %{namedversion} JPP/%{name} bsh-core
%{__cp} -p %{SOURCE4} %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-bsh-reflect.pom
%add_to_maven_depmap org.beanshell bsh-reflect %{namedversion} JPP/%{name} bsh-reflect
%{__cp} -p %{SOURCE5} %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-bsh-util.pom
%add_to_maven_depmap org.beanshell bsh-util %{namedversion} JPP/%{name} bsh-util
%{__cp} -p %{SOURCE6} %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-bsh.pom
%add_to_maven_depmap org.beanshell bsh %{namedversion} JPP/%{name} bsh
%{__cp} -p %{SOURCE7} %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-bsh-bsf.pom
%add_to_maven_depmap org.beanshell bsh-bsf %{namedversion} JPP/%{name} bsh-bsf
%{__cp} -p %{SOURCE8} %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-bsh-classgen.pom
%add_to_maven_depmap org.beanshell bsh-classgen %{namedversion} JPP/%{name} bsh-classgen
%{__cp} -p %{SOURCE10} %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-beanshell.pom
%add_to_maven_depmap org.beanshell beanshell %{namedversion} JPP/%{name} beanshell

# demo
%{__mkdir_p} %{buildroot}%{_datadir}/%{name}
%{__cp} -pr tests %{buildroot}%{_datadir}/%{name}

# scripts
%{__mkdir_p} %{buildroot}%{_bindir}
%{__cat} > %{buildroot}%{_bindir}/%{name} << EOF
#!/bin/sh
#
# %{name} script
# JPackage Project (http://jpackage.sourceforge.net)

# Source functions library
. %{_datadir}/java-utils/java-functions

# Source system prefs
if [ -f %{_sysconfdir}/%{name}.conf ] ; then
    . %{_sysconfdir}/%{name}.conf
fi

# Source user prefs
if [ -f \$HOME/.%{name}rc ] ; then
    . \$HOME/.%{name}rc
fi

# Configuration
MAIN_CLASS=bsh.Interpreter
if [ -n "\$BSH_DEBUG" ]; then
    BASE_FLAGS=-Ddebug=true
fi

BASE_JARS="%{name}"

# Set parameters
set_jvm
set_classpath \$BASE_JARS
set_flags \$BASE_FLAGS
set_options \$BASE_OPTIONS

# Let's start
run "\$@"
EOF

%{__cat} > %{buildroot}%{_bindir}/%{name}doc << EOF
#!%{_bindir}/%{name}
EOF
%{__cat} scripts/bshdoc.bsh >> %{buildroot}%{_bindir}/%{name}doc

%if %with repolib
%{__mkdir_p} %{buildroot}%{repodir}

%{_bindir}/mvn-jpp deploy:deploy-file -DgroupId=org.beanshell -DartifactId=bsh-classpath -Dversion=%{namedversion} -Dpackaging=jar -Dfile=%{buildroot}%{_javadir}/%{name}/bsh-classpath.jar -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-bsh-classpath.pom -Durl=file:%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/ -DrepositoryId=jboss-releases

%{_bindir}/mvn-jpp deploy:deploy-file -DgroupId=org.beanshell -DartifactId=bsh-commands -Dversion=%{namedversion} -Dpackaging=jar -Dfile=%{buildroot}%{_javadir}/%{name}/bsh-commands.jar -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-bsh-commands.pom -Durl=file:%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/ -DrepositoryId=jboss-releases

%{_bindir}/mvn-jpp deploy:deploy-file -DgroupId=org.beanshell -DartifactId=bsh-core -Dversion=%{namedversion} -Dpackaging=jar -Dfile=%{buildroot}%{_javadir}/%{name}/bsh-core.jar -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-bsh-core.pom -Durl=file:%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/ -DrepositoryId=jboss-releases

%{_bindir}/mvn-jpp deploy:deploy-file -DgroupId=org.beanshell -DartifactId=bsh-reflect -Dversion=%{namedversion} -Dpackaging=jar -Dfile=%{buildroot}%{_javadir}/%{name}/bsh-reflect.jar -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-bsh-reflect.pom -Durl=file:%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/ -DrepositoryId=jboss-releases

%{_bindir}/mvn-jpp deploy:deploy-file -DgroupId=org.beanshell -DartifactId=bsh-util -Dversion=%{namedversion} -Dpackaging=jar -Dfile=%{buildroot}%{_javadir}/%{name}/bsh-util.jar -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-bsh-util.pom -Durl=file:%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/ -DrepositoryId=jboss-releases

%{_bindir}/mvn-jpp deploy:deploy-file -DgroupId=org.beanshell -DartifactId=bsh -Dversion=%{namedversion} -Dpackaging=jar -Dfile=%{buildroot}%{_javadir}/%{name}/bsh.jar -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-bsh.pom -Durl=file:%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/ -DrepositoryId=jboss-releases

%{_bindir}/mvn-jpp deploy:deploy-file -DgroupId=org.beanshell -DartifactId=bsh-bsf -Dversion=%{namedversion} -Dpackaging=jar -Dfile=%{buildroot}%{_javadir}/%{name}/bsh-bsf.jar -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-bsh-bsf.pom -Durl=file:%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/ -DrepositoryId=jboss-releases

%{_bindir}/mvn-jpp deploy:deploy-file -DgroupId=org.beanshell -DartifactId=bsh-classgen -Dversion=%{namedversion} -Dpackaging=jar -Dfile=%{buildroot}%{_javadir}/%{name}/bsh-classgen.jar -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-bsh-classgen.pom -Durl=file:%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/ -DrepositoryId=jboss-releases

%{_bindir}/mvn-jpp deploy:deploy-file -DgroupId=org.beanshell -DartifactId=beanshell -Dversion=%{namedversion} -Dfile=%{SOURCE10} -DpomFile=%{SOURCE10} -Durl=file:%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/ -DrepositoryId=jboss-releases

%if 0
# add bsh:bsh structure and install the redirecting pom
%{_bindir}/mvn-jpp deploy:deploy-file -DgroupId=bsh -DartifactId=bsh -Dversion=%{namedversion} -Dfile=%{SOURCE9} -DpomFile=%{SOURCE9} -Durl=file:%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/ -DrepositoryId=jboss-releases
%endif

%{__mkdir_p} %{buildroot}%{repodirlib}
%{__cp} -p %{SOURCE11} %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{name}-%{version}-%{release} | %{__sed} 's|\.|_|g'`
%{__sed} -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
%{__sed} -i "s/@VERSION@/%{namedversion}-brew/g" %{buildroot}%{repodir}/component-info.xml
%{__mkdir_p} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE0} %{buildroot}%{repodirsrc}
%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-bsh-classpath.pom %{buildroot}%{repodirlib}/bsh-classpath.pom
%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-bsh-commands.pom %{buildroot}%{repodirlib}/bsh-commands.pom
%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-bsh-core.pom %{buildroot}%{repodirlib}/bsh-core.pom
%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-bsh-reflect.pom %{buildroot}%{repodirlib}/bsh-reflect.pom
%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-bsh-util.pom %{buildroot}%{repodirlib}/bsh-util.pom
%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-bsh.pom %{buildroot}%{repodirlib}/bsh.pom
%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-bsh-bsf.pom %{buildroot}%{repodirlib}/bsh-bsf.pom
%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-bsh-classgen.pom %{buildroot}%{repodirlib}/bsh-classgen.pom
%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-beanshell.pom %{buildroot}%{repodirlib}/beanshell.pom
%if 0
%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-bsh-redirect.pom %{buildroot}%{repodirlib}/bsh-redirect.pom
%endif
%{__cp} -p %{buildroot}%{_javadir}/%{name}/bsh-bsf.jar %{buildroot}%{repodirlib}/bsh-bsf.jar
%{__cp} -p %{buildroot}%{_javadir}/%{name}/bsh-classgen.jar %{buildroot}%{repodirlib}/bsh-classgen.jar
%{__cp} -p %{buildroot}%{_javadir}/%{name}/bsh-classpath.jar %{buildroot}%{repodirlib}/bsh-classpath.jar
%{__cp} -p %{buildroot}%{_javadir}/%{name}/bsh-commands.jar %{buildroot}%{repodirlib}/bsh-commands.jar
%{__cp} -p %{buildroot}%{_javadir}/%{name}/bsh-core.jar %{buildroot}%{repodirlib}/bsh-core.jar
%{__cp} -p %{buildroot}%{_javadir}/%{name}/bsh.jar %{buildroot}%{repodirlib}/bsh.jar
%{__cp} -p %{buildroot}%{_javadir}/%{name}/bsh-reflect.jar %{buildroot}%{repodirlib}/bsh-reflect.jar
%{__cp} -p %{buildroot}%{_javadir}/%{name}/bsh-util.jar %{buildroot}%{repodirlib}/bsh-util.jar

# FIXME maven bug: the pom for artifact org.beanshell:bsh goes under a null directory
if [ -d %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/org/beanshell/bsh/null ] ; then
    pushd %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/org/beanshell/bsh
    mv null 2.0b4
    popd
fi

# FIXME maven bug: the pom for artifact bsh:bsh goes under version 1.3.0, while the jars went under 2.0b4. 
# move poms over to 2.0b4, remove jars, because it is just a redirecting pom, there are no jars.  
if [ -d %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/bsh/bsh/1.3.0 ]; then
    pushd %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/bsh/bsh
    rm -rf 2.0b4/*
    mv 1.3.0/* 2.0b4/
    rm -rf 1.3.0/
    popd
fi
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap 

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc src/Changes.html src/License.txt src/README.txt
%attr(0755,root,root) %{_bindir}/%{name}
%attr(0755,root,root) %{_bindir}/%{name}doc
%dir %{_javadir}*/%{name}
%exclude %dir %{_javadocdir}/%{name}
%{_javadir}*/%{name}/bsh-%{namedversion}.jar
%{_javadir}*/%{name}/bsh.jar
%{_javadir}*/%{name}/bsh-classpath-%{namedversion}.jar
%{_javadir}*/%{name}/bsh-classpath.jar
%{_javadir}*/%{name}/bsh-commands-%{namedversion}.jar
%{_javadir}*/%{name}/bsh-commands.jar
%{_javadir}*/%{name}/bsh-core-%{namedversion}.jar
%{_javadir}*/%{name}/bsh-core.jar
%{_javadir}*/%{name}/bsh-reflect-%{namedversion}.jar
%{_javadir}*/%{name}/bsh-reflect.jar
%{_javadir}*/%{name}/bsh-util-%{namedversion}.jar
%{_javadir}*/%{name}/bsh-util.jar
%{_datadir}/maven2/poms/JPP.%{name}-beanshell.pom
%{_datadir}/maven2/poms/JPP.%{name}-bsh-classpath.pom
%{_datadir}/maven2/poms/JPP.%{name}-bsh-commands.pom
%{_datadir}/maven2/poms/JPP.%{name}-bsh-core.pom
%{_datadir}/maven2/poms/JPP.%{name}-bsh-reflect.pom
%{_datadir}/maven2/poms/JPP.%{name}-bsh-util.pom
%{_datadir}/maven2/poms/JPP.%{name}-bsh.pom
%{_mavendepmapfragdir}/%{name}

%files bsf
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}/bsh-bsf-%{namedversion}.jar
%{_javadir}*/%{name}/bsh-bsf.jar
%{_datadir}/maven2/poms/JPP.%{name}-bsh-bsf.pom

%files classgen
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}/bsh-classgen-%{namedversion}.jar
%{_javadir}*/%{name}/bsh-classgen.jar
%{_datadir}/maven2/poms/JPP.%{name}-bsh-classgen.pom

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-doc

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%files demo
%defattr(0644,root,root,0755)
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/tests
%doc %{_datadir}/%{name}/tests/README.txt
%attr(0755,root,root) %{_datadir}/%{name}/tests/TestTemplate.bsh
%dir %{_datadir}/%{name}/tests/src
%{_datadir}/%{name}/tests/src/Base.java
%{_datadir}/%{name}/tests/src/Exceptions.java
%{_datadir}/%{name}/tests/src/Fields.java
%{_datadir}/%{name}/tests/src/Inherit.java
%dir %{_datadir}/%{name}/tests/src/InheritanceTest
%{_datadir}/%{name}/tests/src/InheritanceTest/A.java
%{_datadir}/%{name}/tests/src/InheritanceTest/Accessor.java
%{_datadir}/%{name}/tests/src/InheritanceTest/B.java
%{_datadir}/%{name}/tests/src/InheritanceTest/C.java
%{_datadir}/%{name}/tests/src/InheritanceTest/W.java
%{_datadir}/%{name}/tests/src/InheritanceTest/X.java
%{_datadir}/%{name}/tests/src/InheritanceTest/Y.java
%{_datadir}/%{name}/tests/src/InheritanceTest/Z.java
%{_datadir}/%{name}/tests/src/InnerClass.java
%{_datadir}/%{name}/tests/src/Interface.java
%{_datadir}/%{name}/tests/src/InterfaceConsumer.java
%{_datadir}/%{name}/tests/src/InterfaceImpl.java
%{_datadir}/%{name}/tests/src/MethodSelection.java
%dir %{_datadir}/%{name}/tests/src/ambiguous
%dir %{_datadir}/%{name}/tests/src/ambiguous/pkg1
%{_datadir}/%{name}/tests/src/ambiguous/pkg1/Foo.java
%dir %{_datadir}/%{name}/tests/src/ambiguous/pkg2
%{_datadir}/%{name}/tests/src/ambiguous/pkg2/Foo.java
%{_datadir}/%{name}/tests/src/callFromJava.java
%dir %{_datadir}/%{name}/tests/src/mypackage
%{_datadir}/%{name}/tests/src/mypackage/AbstractBase.java
%{_datadir}/%{name}/tests/src/mypackage/Accessibility1.java
%{_datadir}/%{name}/tests/src/mypackage/Accessibility2.java
%{_datadir}/%{name}/tests/src/mypackage/Concrete.java
%{_datadir}/%{name}/tests/src/mypackage/MyClass.java
%{_datadir}/%{name}/tests/src/mypackage/ReflectTest.java
%attr(0755,root,root) %{_datadir}/%{name}/tests/src/mypackage/testCommand.bsh
%dir %{_datadir}/%{name}/tests/test-scripts
%dir %{_datadir}/%{name}/tests/test-scripts/Data
%{_datadir}/%{name}/tests/test-scripts/Data/AddClass.java
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/Data/actionHandler.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/Data/addedCommand.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/Data/import_aux1.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/Data/import_aux2.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/Data/run_aux.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/Data/run_aux2.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/Data/syntaxerrors.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/Fail.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/RunAllTests.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/TestHarness.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/accessibility.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/anoninner.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/arithmetic1.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/array1.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/arraydims.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/arraylen.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/basic.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/binding.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/blockscope.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/braces.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/breakcontinue.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/caller.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/casts.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/class.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/class10.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/class11.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/class12.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/class13.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/class14.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/class15.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/class2.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/class3.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/class4.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/class5.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/class6.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/class7.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/class8.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/class9.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/classinterf1.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/classmisc1.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/classprimparams.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/classreload.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/classser.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/classsuper.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/classsuper1.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/classsuper2.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/closurescoping1.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/commands.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/comments.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/dowhile.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/errors1.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/errsok1.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/eval.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/evalerrors.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/exceptions.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/exceptions2.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/exceptions3.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/exceptions4.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/expressions.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/extend.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/externalNameSpace.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/fields1.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/fields2.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/forenhanced.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/forleakage.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/forscope.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/forscope2.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/forscope3.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/forscope4.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/hash.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/hellotest.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/iftest.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/import.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/import2.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/import3.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/import4.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/inherit.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/innerclass.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/innerclass2.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/interface.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/invoke.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/iterator.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/methods1.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/methods2.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/methods3.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/methodselection.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/methodselection2.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/modifiers.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/newscoping.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/operators.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/overload.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/parserissues1.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/postincrement.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/precedence1.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/primitives.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/primitives2.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/props.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/recurse1.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/recurse2.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/return.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/return2.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/run.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/saveworld.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/scope1.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/scope2.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/serializable.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/serializable2.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/serializable3.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/sourcereturn.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/strictj.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/strings.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/switch.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/switch2.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/synchronized.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/termevaluation1.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/ternaryexp.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/testnullinvocation.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/this.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/threads.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/tryscope.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/types.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/undeclaredthrowable.bsh
%attr(0755,root,root) %{_datadir}/%{name}/tests/test-scripts/useinterpreter.bsh

%files bshservlet
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}/bshservlet.war

%files bshservlet-wbsh
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}/bshservlet-wbsh.war

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Fri May 06 2011 David Walluck <dwalluck@redhat.com> 0:2.0-0.b4.11
- rebuild

* Fri May 06 2011 David Walluck <dwalluck@redhat.com> 0:2.0-0.b4.10
- enable non-empty bsh-bsf.jar
- don't try to remove internal asm code
- enable servlet in build (adding bshservlet and bshservlet-wbsh packages)
- replace bsh2 in paths and pom names with %%{name}
- remove AutoReqProv: no from demo package
- fix macro in changelog
- move manual location so as to not conflict with doc dir

* Thu May 05 2011 David Walluck <dwalluck@redhat.com> 0:2.0-0.b4.9
- don't own javadoc dir in main package
- fix maven depmaps
- remove javadoc scriptlets
- add xsl patch
- fix bsh-bsf duplication across packages
- require jpackage-utils for maven scriptlets and javadoc
- make bsf and classgen subpackages require main package
- own data dir in demo package
- fix removal of internal asm code
- fix build failure
- use backwards compatible maven BuildRequires
- use full version in dir and jar names
- fix License
- fix defines and options

* Wed Feb 9 2011 Yiqiao Wang <yiwang@redhat.com> 0:2.0-0.b4.8
- Add add %%update_maven_depmap in %%post and %%postun

* Fri Jan 28 2011 Yiqiao Wang <yiwang@redhat.com> 0:2.0-0.b4.7
- Fix parameters to add_to_maven_depmap macro (change %%{name} to artifactId)
- Change installed pom names from JPP.bsh2-<artifactId>.pom to JPP.%%{name}-<artifactId>.pom

* Fri Jan 28 2011 Fernando nasser <fnasser@redhat.com> 0:2.0-0.b4.6
- Fix pom file names and fragments

* Fri Jan 14 2011 Yiqiao Wang <yiwang@redhat.com> 0:2.0-0.b4.5
- Generate artifacts org.beanshell:bsh, org.beanshell:bsh-classgen, and org.beanshell:bsh-bsf for maven2-brew
- Generate artifact org.beanshell:beanshell for maven2-brew
- Added bsh:bsh redirecting pom, but leave it in comment because of MEAD error

* Tue Jan 11 2011 Yiqiao Wang <yiwang@redhat.com> 0:2.0-0.b4.3
- Add repolib subpkg
- Add poms to repolib

* Tue Jan 11 2011 Yiqiao Wang <yiwang@redhat.com> 0:2.0-0.b4.2
- Rebuild on RHEL6
- Fix %%{files} for signed jars
- Add BR ant-trax

* Tue Jun 26 2007 Fernando Nasser <fnasser@redhat.com> 0:2.0-0.b4.1jpp.ep.1
- Merge with upstream for upgrade

* Tue Jun 26 2007 Fernando Nasser <fnasser@redhat.com> 0:2.0-0.b4.1jpp
- Upgrade to 2.0b4

* Wed May 24 2006 Fernando Nasser <fnasser@redhat.com> 0:2.0-0.b1.9jpp_1rh
- First Red Hat build

* Fri May 19 2006 Fernando Nasser <fnasser@redhat.com> 0:2.0-0.b1.9jpp
- First JPP 1.7 build

* Wed Mar 16 2005 Ralph Apel <r.apel at r-apel.de> 0:2.0-0.b1.8jpp
- Patch to adapt to asm-1.5.3
- Buildrequire asm >= 0:1.5.3

* Wed Feb 16 2005 Ralph Apel <r.apel at r-apel.de> 0:2.0-0.b1.7jpp
- But build with javac 1.4.2

* Sun Feb 06 2005 David Walluck <david@jpackage.org> 0:2.0-0.b1.6jpp
- add patch for building with javac 1.5
- add patch for javadoc crosslinking
- add non-versioned javadoc link
- fix demo execution
- modernize spec

* Fri Aug 20 2004 Ralph Apel <r.apel at r-apel.de> 0:2.0-0.b1.5jpp
- Build with ant-1.6.2

* Tue Jan 27 2004 David Walluck <david@anti-microsoft.org> 0:2.0-0.b1.4jpp
- new jedit patch

* Mon Jan 26 2004 David Walluck <david@anti-microsoft.org> 0:2.0-0.b1.3jpp
- really drop readline patch
- don't add servlet to build classpath

* Sun Jan 25 2004 David Walluck <david@anti-microsoft.org> 0:2.0-0.b1.2jpp
- drop readline patch
- modularize to split out asm and bsf dependencies

* Thu Jan 22 2004 David Walluck <david@anti-microsoft.org> 0:2.0-0.b1.1jpp
- release
